## libchewing 0.8.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24.0)
project(libchewing LANGUAGES C)

set(CMAKE_PROJECT_VERSION 0.8.4)
set(LIBCHEWING_VERSION ${CMAKE_PROJECT_VERSION})
set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(LIBCHEWING_BINARY_VERSION 1.0.0)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(CTest)
set(CTEST_PARALLEL_LEVEL 1)

if(UNIX)
    set(CMAKE_C_FLAGS "-g -O2 -Wall -fPIC ${CMAKE_C_FLAGS}")
    add_compile_definitions(UNDER_POSIX PIC)
endif()

if(MSVC)
    set(CMAKE_C_FLAGS "/utf-8 ${CMAKE_C_FLAGS}")
endif()

include(CheckCCompilerFlag)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
    set(CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
    add_compile_definitions(_GNU_SOURCE)
    option(ENABLE_GCOV "Coverage support" false)
    if(ENABLE_GCOV)
        if(WITH_RUST AND CMAKE_C_COMPILER_ID MATCHES Clang)
            set(CMAKE_C_FLAGS "-fprofile-instr-generate -fcoverage-mapping ${CMAKE_C_FLAGS}")
        else()
            set(CMAKE_C_FLAGS "--coverage ${CMAKE_C_FLAGS}")
        endif()
    endif()

    # Use NO_UNDEFINED=no when running with address sanitizer
    option(NO_UNDEFINED "No undefined symbol in object file" true)
    if(NO_UNDEFINED)
        set(saved_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
        set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
        check_c_compiler_flag("" HAVE_NO_UNDEFINED)
        set(CMAKE_REQUIRED_FLAGS ${saved_CMAKE_REQUIRED_FLAGS})

        if(HAVE_NO_UNDEFINED)
            set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined ${CMAKE_SHARED_LINKER_FLAGS}")
        endif()
    endif()
elseif(MSVC)
    # /wd4819
    # Without BOM, Visual Studio does not treat source file as UTF-8
    # encoding, thus it will complain about invalid character. Use
    # /wd4819 can suppress this warning.
    set(CMAKE_C_FLAGS "/wd4819 ${CMAKE_C_FLAGS}")
    add_compile_definitions(_CRT_SECURE_NO_WARNINGS _CRT_NONSTDC_NO_DEPRECATE)
    add_compile_definitions(__func__=__FUNCTION__)

    # MSVC 2015 supports `snprintf`, so no need to redefine it
    if(MSVC_VERSION LESS 1900)
        add_compile_definitions(snprintf=_snprintf)
    endif()
endif()


check_c_compiler_flag(-fvisibility=hidden FVISIBILITY_HIDDEN)
if(${FVISIBILITY_HIDDEN})
    set(CMAKE_C_FLAGS "-fvisibility=hidden ${CMAKE_C_FLAGS}")
endif()

# automake compatibility
add_compile_definitions(HAVE_CONFIG_H=1)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

option(WITH_SQLITE3 "Use sqlite3 to store userphrase" true)
option(WITH_INTERNAL_SQLITE3 "Use internal sqlite3" false)
if(MSVC)
    set(WITH_INTERNAL_SQLITE3 true)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Android")
    set(WITH_INTERNAL_SQLITE3 true)
endif()

# Use valgrind when testing
option(USE_VALGRIND "Use valgrind when testing" true)

option(WITH_RUST "Use rust implemented internals" true)
if(WITH_RUST)
    find_package(Corrosion QUIET)
    if(NOT Corrosion_FOUND)
        include(FetchContent)
        FetchContent_Declare(
            Corrosion
            GIT_REPOSITORY https://github.com/corrosion-rs/corrosion.git
            GIT_TAG be76480232216a64f65e3b1d9794d68cbac6c690 # v0.4.5
            FIND_PACKAGE_ARGS
        )
        FetchContent_MakeAvailable(Corrosion)
    endif()

    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_capi)
    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-cli)
    add_compile_definitions(WITH_RUST)
    if(WITH_SQLITE3)
        corrosion_set_features(chewing_capi FEATURES sqlite)
        corrosion_set_features(chewing_testhelper FEATURES sqlite)
    endif()
    if(ENABLE_GCOV)
        corrosion_set_env_vars(chewing_capi CARGO_INCREMENTAL=0)
        corrosion_add_target_local_rustflags(chewing_capi -Cinstrument-coverage -Ccodegen-units=1 -Cinline-threshold=0 -Clink-dead-code -Coverflow-checks=off -Cpanic=abort)
    endif()
endif()

# Feature probe
include(CheckTypeSize)
check_type_size(uint16_t UINT16_T)

set(CURSES_NEED_WIDE true)
find_package(Curses)

if(WITH_SQLITE3)
    if(WITH_INTERNAL_SQLITE3)
        set(SQLITE3_SRC_DIR ${PROJECT_SOURCE_DIR}/thirdparty/sqlite-amalgamation)
        include_directories(
            ${SQLITE3_SRC_DIR}
        )
        find_package (Threads)
        add_library(sqlite3_library STATIC
            ${SQLITE3_SRC_DIR}/sqlite3.c
            ${SQLITE3_SRC_DIR}/sqlite3.h
        )
        target_link_libraries(sqlite3_library ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})

        add_executable(sqlite3
            ${SQLITE3_SRC_DIR}/shell.c
        )
        target_link_libraries(sqlite3 sqlite3_library)
        set_target_properties(sqlite3 PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${SQLITE3_SRC_DIR}
        )
        set(SQLite3_LIBRARIES sqlite3_library)
    else()
        find_package(SQLite3 REQUIRED)
        include_directories(SQLite3_INCLUDE_DIRS)
    endif()
endif()

include(CheckFunctionExists)
check_function_exists(strtok_r HAVE_STRTOK_R)
check_function_exists(asprintf HAVE_ASPRINTF)

include(CheckIncludeFiles)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(stdint.h HAVE_STDINT_H)

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(INC_DIR ${PROJECT_SOURCE_DIR}/include)
set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/tests)
set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/tests)

include(GNUInstallDirs)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/config.h.in
    ${PROJECT_BINARY_DIR}/include/config.h
)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/version.texi.in
    ${PROJECT_BINARY_DIR}/doc/version.texi
)

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(datarootdir "\${prefix}/share")
set(datadir "\${datarootdir}")
set(sysconfdir "\${prefix}/etc")
configure_file(
    ${PROJECT_SOURCE_DIR}/chewing.pc.in
    ${PROJECT_BINARY_DIR}/chewing.pc
    @ONLY
)

include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/include/internal
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/porting_layer/include
)

set(ALL_INC
    ${INC_DIR}/chewing.h
    ${INC_DIR}/chewing-compat.h
    ${INC_DIR}/chewingio.h
    ${INC_DIR}/global.h
    ${INC_DIR}/mod_aux.h
)

if(WITH_RUST)
    list(APPEND ALL_INC ${INC_DIR}/chewing_rs.h)
endif()

add_subdirectory(doc)
add_subdirectory(data)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

# library
add_library(common OBJECT
    src/porting_layer/src/asprintf.h

    src/porting_layer/src/asprintf.c
)
target_compile_definitions(common PRIVATE
    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
)

add_library(libchewing ${ALL_INC} src/chewing.c)
set_target_properties(libchewing PROPERTIES LINKER_LANGUAGE C)
target_compile_definitions(libchewing PRIVATE
    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
)
if(NOT WITH_RUST)
    target_sources(common PRIVATE
        ${SRC_DIR}/porting_layer/include/plat_mmap.h
        ${SRC_DIR}/porting_layer/include/plat_path.h
        ${SRC_DIR}/porting_layer/include/plat_types.h
        ${SRC_DIR}/porting_layer/include/sys/plat_posix.h
        ${SRC_DIR}/porting_layer/include/sys/plat_windows.h

        ${SRC_DIR}/porting_layer/src/plat_mmap_posix.c
        ${SRC_DIR}/porting_layer/src/plat_mmap_windows.c
        ${SRC_DIR}/porting_layer/src/plat_path.c
        ${SRC_DIR}/porting_layer/src/rpl_malloc.c
        ${SRC_DIR}/common/chewing-utf8-util.c
        ${SRC_DIR}/common/key2pho.c
    )
    target_sources(libchewing PRIVATE
        ${INC_DIR}/internal/bopomofo-private.h
        ${INC_DIR}/internal/chewing-private.h
        ${INC_DIR}/internal/chewingutil.h
        ${INC_DIR}/internal/choice-private.h
        ${INC_DIR}/internal/dict-private.h
        ${INC_DIR}/internal/global-private.h
        ${INC_DIR}/internal/pinyin-private.h
        ${INC_DIR}/internal/tree-private.h
        ${INC_DIR}/internal/userphrase-private.h

        ${SRC_DIR}/bopomofo.c
        ${SRC_DIR}/chewingio.c
        ${SRC_DIR}/chewingutil.c
        ${SRC_DIR}/choice.c
        ${SRC_DIR}/compat.c
        ${SRC_DIR}/dict.c
        ${SRC_DIR}/mod_aux.c
        ${SRC_DIR}/pinyin.c
        ${SRC_DIR}/private.h
        ${SRC_DIR}/tree.c
        ${SRC_DIR}/userphrase.c
    )
    if(WITH_SQLITE3)
        add_library(userphrase OBJECT
            ${INC_DIR}/internal/chewing-sql.h
            ${SRC_DIR}/chewing-sql.c
            ${SRC_DIR}/userphrase-sql.c
        )
    else()
        add_library(userphrase OBJECT
            ${INC_DIR}/internal/hash-private.h
            ${SRC_DIR}/hash.c
            ${SRC_DIR}/userphrase-hash.c
        )
    endif()
    target_link_libraries(libchewing
        PRIVATE common
        PRIVATE userphrase)
    if(BUILD_SHARED_LIBS AND MSVC)
        target_compile_definitions(libchewing PRIVATE CHEWINGDLL_EXPORTS)
    endif()
endif()

if(WITH_RUST)
    corrosion_set_env_vars(chewing_capi
        CHEWING_DATADIR=${CMAKE_INSTALL_FULL_DATADIR}/libchewing
    )
    target_link_libraries(libchewing PRIVATE chewing_capi)
    target_link_libraries(chewing_capi INTERFACE ${SQLite3_LIBRARIES})
    if(BUILD_SHARED_LIBS)
        if(CMAKE_C_COMPILER_ID MATCHES GNU|^Clang)
            target_link_options(libchewing
                PRIVATE LINKER:-version-script,${PROJECT_SOURCE_DIR}/src/symbols-elf.map
                PRIVATE LINKER:--gc-sections
                PRIVATE LINKER:-u,chewing_new
                PRIVATE LINKER:-u,ueStrLen
                PRIVATE LINKER:-u,UintFromPhone
                PRIVATE LINKER:-u,find_path_by_files
            )
        elseif(CMAKE_C_COMPILER_ID MATCHES AppleClang)
            target_link_options(libchewing
                PRIVATE LINKER:-exported_symbols_list,${PROJECT_SOURCE_DIR}/src/symbols-mach_o.map
                PRIVATE LINKER:-dead_strip
            )
        elseif(MSVC)
            target_link_options(libchewing
                PRIVATE /DEF:${PROJECT_SOURCE_DIR}/src/symbols-msvc.def)
            set_target_properties(libchewing PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
        endif()
    endif()
elseif(WITH_SQLITE3)
   target_link_libraries(libchewing PRIVATE ${SQLite3_LIBRARIES})
endif()

if(MSVC)
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing-msvc
    )
else()
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing
        SOVERSION 3
        VERSION 3.3.1
    )
endif()

install(FILES ${ALL_INC} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/chewing)
install(FILES ${PROJECT_BINARY_DIR}/chewing.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS libchewing DESTINATION ${CMAKE_INSTALL_LIBDIR})
if(WITH_RUST)
    install(IMPORTED_RUNTIME_ARTIFACTS chewing-cli DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()


set(CPACK_PACKAGE_CHECKSUM SHA256)
set(CPACK_PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(CPACK_SOURCE_IGNORE_FILES "/build" "/out" "/target" "/\\\\..*")
set(CPACK_SOURCE_GENERATOR TZST)
set(CPACK_SOURCE_PACKAGE_FILE_NAME libchewing-${CMAKE_PROJECT_VERSION})
include(CPack)

=== data/CMakeLists.txt ===
if(WITH_RUST)
    set(ALL_DATA
        ${DATA_BIN_DIR}/tsi.dat
        ${DATA_BIN_DIR}/word.dat
    )
else()
    set(ALL_DATA
        ${DATA_BIN_DIR}/dictionary.dat
        ${DATA_BIN_DIR}/index_tree.dat
    )
endif()

add_custom_target(data ALL DEPENDS ${ALL_DATA})

# We need to copy static data to binary tree when using out of tree build.
set(ALL_STATIC_DATA
    ${DATA_SRC_DIR}/pinyin.tab
    ${DATA_SRC_DIR}/swkb.dat
    ${DATA_SRC_DIR}/symbols.dat
)

add_custom_target(all_static_data
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/pinyin.tab ${DATA_BIN_DIR}/pinyin.tab
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/swkb.dat ${DATA_BIN_DIR}/swkb.dat
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/symbols.dat ${DATA_BIN_DIR}/symbols.dat
)

# tools
set(ALL_TOOLS init_database)

if(NOT WITH_RUST)
    list(APPEND ALL_TOOLS dump_database)
    add_executable(init_database ${TOOLS_SRC_DIR}/init_database.c $<TARGET_OBJECTS:common>)
    add_executable(dump_database
        ${TOOLS_SRC_DIR}/dump_database.c
        $<TARGET_OBJECTS:common>
    )
    set_target_properties(${ALL_TOOLS} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${TOOLS_BIN_DIR}
            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TOOLS_BIN_DIR}
            RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${TOOLS_BIN_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TOOLS_BIN_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TOOLS_BIN_DIR}
    )
endif()

# tools command
file(MAKE_DIRECTORY ${DATA_BIN_DIR})
if(WITH_RUST)
    set(DATA_COPYRIGHT "Copyright \\(c\\) 2022 libchewing Core Team")
    set(DATA_LICENSE "LGPL-2.1-or-later")
    set(DATA_VERSION ${LIBCHEWING_VERSION})
    add_custom_command(
        OUTPUT
            ${ALL_DATA}
        COMMAND chewing-cli init-database
            -c ${DATA_COPYRIGHT}
            -l ${DATA_LICENSE}
            -r ${DATA_VERSION}
            -t trie
            -n 內建詞庫
            ${DATA_SRC_DIR}/tsi.src tsi.dat
        COMMAND chewing-cli init-database
            -c ${DATA_COPYRIGHT}
            -l ${DATA_LICENSE}
            -r ${DATA_VERSION}
            -t trie
            -n 內建字庫
            ${DATA_SRC_DIR}/word.src word.dat
        DEPENDS
            chewing-cli
            ${DATA_SRC_DIR}/word.src
            ${DATA_SRC_DIR}/tsi.src
        WORKING_DIRECTORY ${DATA_BIN_DIR}
    )
else()
    add_custom_command(
        OUTPUT
            ${ALL_DATA}
        COMMAND init_database ${DATA_SRC_DIR}/phone.cin ${DATA_SRC_DIR}/tsi.src
        DEPENDS
            ${ALL_TOOLS}
            ${DATA_SRC_DIR}/phone.cin
            ${DATA_SRC_DIR}/tsi.src
        WORKING_DIRECTORY ${DATA_BIN_DIR}
    )
endif()

install(FILES ${ALL_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)
install(FILES ${ALL_STATIC_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)

=== tests/CMakeLists.txt ===
set(ALL_TESTCASES
    test-bopomofo
    test-config
    test-easy-symbol
    test-error-handling
    test-fullshape
    test-keyboard
    test-keyboardless
    test-logger
    test-path
    test-regression
    test-reset
    test-special-symbol
    test-struct-size
    test-symbol
    test-userphrase
    test-utf8
)
if(NOT WITH_RUST)
    list(APPEND ALL_TESTCASES
        test-key2pho
        test-mmap
    )
endif()
set(ALL_TESTTOOLS
    performance
    randkeystroke
    simulate
    stress
    testchewing
)

if(CURSES_FOUND)
    set(ALL_TESTTOOLS ${ALL_TESTTOOLS} genkeystroke)
endif()


set(ALL_TESTS ${ALL_TESTCASES} ${ALL_TESTTOOLS})

foreach(target ${ALL_TESTCASES})
    add_test(
        NAME ${target}
        COMMAND ${TEST_BIN_DIR}/${target}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endforeach()

if(USE_VALGRIND)
    find_program(VALGRIND valgrind)
    if(VALGRIND)
        foreach(target ${ALL_TESTCASES})
            add_test("valgrind-${target}" ${VALGRIND} --error-exitcode=255 --leak-check=full ${TEST_BIN_DIR}/${target})
        endforeach()
    endif()
endif()

foreach(target ${ALL_TESTS})
    add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
    target_link_libraries(${target} testhelper)
    if(WITH_RUST)
        target_link_libraries(${target} chewing_testhelper)
    endif(WITH_RUST)
    target_link_libraries(${target} libchewing)
    target_compile_definitions(${target} PRIVATE
        CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
        TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
        TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
        TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
    )
    add_dependencies(${target} data all_static_data)
    add_dependencies(check ${target})
endforeach()

add_library(testhelper STATIC
    ${TEST_SRC_DIR}/testhelper.c
    $<TARGET_OBJECTS:common>
)
target_compile_definitions(testhelper PRIVATE
    CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
    TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
    TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
    TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
)

set_target_properties(${ALL_TESTS} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TEST_BIN_DIR}
)

if (CURSES_FOUND)
    target_include_directories(genkeystroke PRIVATE ${CURSES_INCLUDE_DIRS})
    target_link_libraries(genkeystroke ${CURSES_LIBRARIES})
endif()

set(ALL_STATIC_TEST stresstest.py)
foreach(target ${ALL_STATIC_TEST})
    add_custom_target(${target} ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TEST_SRC_DIR}/${target} ${TEST_BIN_DIR}/${target}
    )
    add_dependencies(check ${target})
endforeach()

if(WITH_RUST)
add_test(NAME cargo-test-lib COMMAND cargo test --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
add_test(NAME cargo-test-capi COMMAND cargo test -p chewing_capi --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
endif()

=== debian/changelog ===
libchewing (0.8.4-2build1) oracular; urgency=medium

  * No-change rebuild to enable frame pointers

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 01 Jul 2024 17:40:10 +0200

libchewing (0.8.4-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.0.
  * Fix typo in patch file.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 06 Jun 2024 10:21:35 +0800

libchewing (0.8.4-1) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * New upstream release.
  * d/control: Add chewing-tools package for command line tools.
  * d/rules: Use dh_missing to find missing files during packaging.

  [ Kan-Ru Chen (陳侃如) ]
  * Fix Build-Depends for Rust.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 04 Jun 2024 19:59:30 +0800

libchewing (0.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Update d/copyright:
    * Change license to LGPL-2.1+ as described in
      https://github.com/chewing/libchewing/pull/436.
    * Remove unused copyright.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 07 Apr 2024 21:11:03 +0800

## libchewing 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24.0)
project(libchewing LANGUAGES C)

set(CMAKE_PROJECT_VERSION 0.9.0)

find_package(Git)
if(Git_FOUND)
    execute_process(
        COMMAND ${GIT_EXECUTABLE} --work-tree ${CMAKE_SOURCE_DIR} describe --dirty --always
        OUTPUT_STRIP_TRAILING_WHITESPACE
        OUTPUT_VARIABLE GIT_DESCRIBE
        ERROR_VARIABLE GIT_DESCRIBE_ERROR
    )
    if(NOT GIT_DESCRIBE_ERROR)
        string(REPLACE "v" "" CMAKE_PROJECT_VERSION ${GIT_DESCRIBE})
    endif()
endif()

set(LIBCHEWING_VERSION ${CMAKE_PROJECT_VERSION})
set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(LIBCHEWING_BINARY_VERSION 1.0.0)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(CTest)
set(CTEST_PARALLEL_LEVEL 1)

if(UNIX)
    set(CMAKE_C_FLAGS "-g -O2 -Wall -fPIC ${CMAKE_C_FLAGS}")
    add_compile_definitions(UNDER_POSIX PIC)
endif()

if(MSVC)
    set(CMAKE_C_FLAGS "/utf-8 ${CMAKE_C_FLAGS}")
endif()

include(CheckCCompilerFlag)
include(FetchContent)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
    set(CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
    add_compile_definitions(_GNU_SOURCE)
    option(ENABLE_GCOV "Coverage support" false)
    if(ENABLE_GCOV)
        if(CMAKE_C_COMPILER_ID MATCHES Clang)
            set(CMAKE_C_FLAGS "-fprofile-instr-generate -fcoverage-mapping ${CMAKE_C_FLAGS}")
        else()
            set(CMAKE_C_FLAGS "--coverage ${CMAKE_C_FLAGS}")
        endif()
    endif()
endif()

add_compile_definitions(HAVE_CONFIG_H=1)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

option(WITH_SQLITE3 "Use sqlite3 to store userphrase" true)

# Use valgrind when testing
option(USE_VALGRIND "Use valgrind when testing" true)

find_package(Corrosion QUIET)
if(NOT Corrosion_FOUND)
    FetchContent_Declare(
        Corrosion
        GIT_REPOSITORY https://github.com/corrosion-rs/corrosion.git
        GIT_TAG 64289b1d79d6d19cd2e241db515381a086bb8407 # v0.5
        FIND_PACKAGE_ARGS
    )
    FetchContent_MakeAvailable(Corrosion)
endif()

corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_capi)
corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-cli)

if(WITH_SQLITE3)
    corrosion_set_features(chewing_capi FEATURES sqlite)
    corrosion_set_features(chewing_testhelper FEATURES sqlite)
endif()

if(ENABLE_GCOV)
    corrosion_set_env_vars(chewing_capi CARGO_INCREMENTAL=0)
    corrosion_add_target_local_rustflags(chewing_capi -Cinstrument-coverage -Ccodegen-units=1 -Cinline-threshold=0 -Clink-dead-code -Coverflow-checks=off -Cpanic=abort)
endif()

# Feature probe
include(CheckTypeSize)
check_type_size(uint16_t UINT16_T)

set(CURSES_NEED_WIDE true)
find_package(Curses)

if(WITH_SQLITE3)
    find_package(SQLite3 QUIET)
    if(SQLite3_FOUND)
        message(STATUS "Found SQLite3 version ${SQLite3_VERSION}")
        include_directories(SQLite3_INCLUDE_DIRS)
    else()
        message(STATUS "Fetching SQLite3 source from internet")
        FetchContent_Declare(
            SQLite3
            URL https://www.sqlite.org/2024/sqlite-amalgamation-3460000.zip
            URL_HASH SHA3_256=1221eed70de626871912bfca144c00411f0c30d3c2b7935cff3963b63370ef7c
        )
        FetchContent_MakeAvailable(SQLite3)

        include_directories(${sqlite3_SOURCE_DIR})
        add_library(sqlite3_library STATIC
            ${sqlite3_SOURCE_DIR}/sqlite3.c
            ${sqlite3_SOURCE_DIR}/sqlite3.h
        )
        find_package(Threads)
        target_link_libraries(sqlite3_library PUBLIC ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
        set(SQLite3_LIBRARIES sqlite3_library)

        add_executable(sqlite3
            ${sqlite3_SOURCE_DIR}/shell.c
        )
        target_link_libraries(sqlite3 PRIVATE ${SQLite3_LIBRARIES})
        set_target_properties(sqlite3 PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${sqlite3_BINARY_DIR}
            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${sqlite3_BINARY_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${sqlite3_BINARY_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${sqlite3_BINARY_DIR}
            RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${sqlite3_BINARY_DIR}
        )
    endif()
endif()

include(CheckFunctionExists)
check_function_exists(asprintf HAVE_ASPRINTF)

include(CheckIncludeFiles)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(stdint.h HAVE_STDINT_H)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(INC_DIR ${PROJECT_SOURCE_DIR}/include)
set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/tests)
set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/tests)

include(GNUInstallDirs)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/config.h.in
    ${PROJECT_BINARY_DIR}/include/config.h
)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/version.texi.in
    ${PROJECT_BINARY_DIR}/doc/version.texi
)

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(datarootdir "\${prefix}/share")
set(datadir "\${datarootdir}")
set(sysconfdir "\${prefix}/etc")
configure_file(
    ${PROJECT_SOURCE_DIR}/chewing.pc.in
    ${PROJECT_BINARY_DIR}/chewing.pc
    @ONLY
)

include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/src/porting_layer/include
)

set(ALL_INC
    ${INC_DIR}/chewing.h

    # 0.5.x compatibility headers
    ${INC_DIR}/chewing-compat.h
    ${INC_DIR}/chewingio.h
    ${INC_DIR}/global.h
    ${INC_DIR}/mod_aux.h
)

add_subdirectory(doc)
add_subdirectory(data)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

add_library(libchewing ${ALL_INC} capi/src/chewing.c)
set_target_properties(libchewing PROPERTIES LINKER_LANGUAGE C)
target_compile_definitions(libchewing PRIVATE
    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
)
target_include_directories(libchewing
    PUBLIC
        $<BUILD_INTERFACE:${INC_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/chewing>
)

corrosion_set_env_vars(chewing_capi
    CHEWING_DATADIR=${CMAKE_INSTALL_FULL_DATADIR}/libchewing
)
target_link_libraries(libchewing PRIVATE chewing_capi)
target_link_libraries(chewing_capi INTERFACE ${SQLite3_LIBRARIES})
if(BUILD_SHARED_LIBS)
    if(CMAKE_C_COMPILER_ID MATCHES GNU|^Clang)
        target_link_options(libchewing
            PRIVATE LINKER:-version-script,${PROJECT_SOURCE_DIR}/capi/src/symbols-elf.map
            PRIVATE LINKER:--gc-sections
            PRIVATE LINKER:-u,chewing_new
            PRIVATE LINKER:-u,chewing_version
        )
        set_target_properties(libchewing PROPERTIES
            LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-elf.map
        )
    elseif(CMAKE_C_COMPILER_ID MATCHES AppleClang)
        target_link_options(libchewing
            PRIVATE LINKER:-exported_symbols_list,${PROJECT_SOURCE_DIR}/capi/src/symbols-mach_o.map
            PRIVATE LINKER:-dead_strip
        )
        set_target_properties(libchewing PROPERTIES
            LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-mach_o.map
        )
    elseif(MSVC)
        target_link_options(libchewing
            PRIVATE /DEF:${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def)
        set_target_properties(libchewing PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
        set_target_properties(libchewing PROPERTIES
            LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def
        )
    endif()
endif()

if(MSVC)
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing-msvc
    )
else()
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing
        SOVERSION 3
        VERSION 3.3.1
    )
endif()

install(FILES ${ALL_INC} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/chewing)
install(FILES ${PROJECT_BINARY_DIR}/chewing.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS libchewing
    EXPORT libchewingTargets
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(IMPORTED_RUNTIME_ARTIFACTS chewing-cli DESTINATION ${CMAKE_INSTALL_BINDIR})

# generate CMake Config files
include(CMakePackageConfigHelpers)
set(CONFIG_PACKAGE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Chewing")
configure_package_config_file(ChewingConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/ChewingConfig.cmake"
    INSTALL_DESTINATION ${CONFIG_PACKAGE_DIR})
write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/ChewingConfigVersion.cmake"
    VERSION ${LIBCHEWING_VERSION}
    COMPATIBILITY SameMajorVersion)
export(EXPORT libchewingTargets
    NAMESPACE Chewing::
    FILE "${CMAKE_CURRENT_BINARY_DIR}/ChewingTargets.cmake")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ChewingConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/ChewingConfigVersion.cmake"
    DESTINATION ${CONFIG_PACKAGE_DIR})
install(EXPORT libchewingTargets
    FILE ChewingTargets.cmake
    NAMESPACE Chewing::
	DESTINATION ${CONFIG_PACKAGE_DIR})

set(CPACK_PACKAGE_CHECKSUM SHA256)
set(CPACK_PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(CPACK_SOURCE_IGNORE_FILES "/build" "/out" "/target" "/\\\\..*")
set(CPACK_SOURCE_GENERATOR TZST)
set(CPACK_SOURCE_PACKAGE_FILE_NAME libchewing-${CMAKE_PROJECT_VERSION})
include(CPack)

=== debian/changelog ===
libchewing (0.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove unused copyright.
  * Add CMake config.
  * Update symbol file for symbol versioning.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 12 Aug 2024 12:37:40 +0800

libchewing (0.8.5-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 16 Jul 2024 22:59:29 +0800

## libchewing 0.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.9.0)
+set(CMAKE_PROJECT_VERSION 0.9.1)
 
 find_package(Git)
 if(Git_FOUND)
@@ -84,6 +84,16 @@
     corrosion_add_target_local_rustflags(chewing_capi -Cinstrument-coverage -Ccodegen-units=1 -Cinline-threshold=0 -Clink-dead-code -Coverflow-checks=off -Cpanic=abort)
 endif()
 
+if(CMAKE_SYSTEM MATCHES "Windows")
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
+    corrosion_add_target_rustflags(chewing_capi -Ctarget-feature=+crt-static)
+    corrosion_add_target_rustflags(chewing_testhelper -Ctarget-feature=+crt-static)
+    corrosion_add_target_rustflags(chewing-cli -Ctarget-feature=+crt-static)
+    if(VCPKG_TARGET_TRIPLET)
+        corrosion_set_env_vars(chewing-cli VCPKGRS_TRIPLET=${VCPKG_TARGET_TRIPLET})
+    endif()
+endif()
+
 # Feature probe
 include(CheckTypeSize)
 check_type_size(uint16_t UINT16_T)
@@ -92,39 +102,10 @@
 find_package(Curses)
 
 if(WITH_SQLITE3)
-    find_package(SQLite3 QUIET)
+    find_package(SQLite3 REQUIRED)
     if(SQLite3_FOUND)
         message(STATUS "Found SQLite3 version ${SQLite3_VERSION}")
         include_directories(SQLite3_INCLUDE_DIRS)
-    else()
-        message(STATUS "Fetching SQLite3 source from internet")
-        FetchContent_Declare(
-            SQLite3
-            URL https://www.sqlite.org/2024/sqlite-amalgamation-3460000.zip
-            URL_HASH SHA3_256=1221eed70de626871912bfca144c00411f0c30d3c2b7935cff3963b63370ef7c
-        )
-        FetchContent_MakeAvailable(SQLite3)
-
-        include_directories(${sqlite3_SOURCE_DIR})
-        add_library(sqlite3_library STATIC
-            ${sqlite3_SOURCE_DIR}/sqlite3.c
-            ${sqlite3_SOURCE_DIR}/sqlite3.h
-        )
-        find_package(Threads)
-        target_link_libraries(sqlite3_library PUBLIC ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
-        set(SQLite3_LIBRARIES sqlite3_library)
-
-        add_executable(sqlite3
-            ${sqlite3_SOURCE_DIR}/shell.c
-        )
-        target_link_libraries(sqlite3 PRIVATE ${SQLite3_LIBRARIES})
-        set_target_properties(sqlite3 PROPERTIES
-            RUNTIME_OUTPUT_DIRECTORY ${sqlite3_BINARY_DIR}
-            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${sqlite3_BINARY_DIR}
-            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${sqlite3_BINARY_DIR}
-            RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${sqlite3_BINARY_DIR}
-            RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${sqlite3_BINARY_DIR}
-        )
     endif()
 endif()
 
@@ -228,8 +209,10 @@
         )
     elseif(MSVC)
         target_link_options(libchewing
-            PRIVATE /DEF:${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def)
-        set_target_properties(libchewing PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
+            PRIVATE /DEF:${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def
+            PRIVATE /NODEFAULTLIB:MSVCRT
+            PRIVATE /NODEFAULTLIB:MSVCRTD
+        )
         set_target_properties(libchewing PROPERTIES
             LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def
         )

=== data/CMakeLists.txt ===
set(ALL_DATA
    ${DATA_BIN_DIR}/tsi.dat
    ${DATA_BIN_DIR}/word.dat
)

add_custom_target(data ALL DEPENDS ${ALL_DATA})

# We need to copy static data to binary tree when using out of tree build.
set(ALL_STATIC_DATA
    ${DATA_SRC_DIR}/swkb.dat
    ${DATA_SRC_DIR}/symbols.dat
)

add_custom_target(all_static_data
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/swkb.dat ${DATA_BIN_DIR}/swkb.dat
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/symbols.dat ${DATA_BIN_DIR}/symbols.dat
)

# tools
set(ALL_TOOLS init_database)

# tools command
file(MAKE_DIRECTORY ${DATA_BIN_DIR})
set(DATA_COPYRIGHT "Copyright \\(c\\) 2022 libchewing Core Team")
set(DATA_LICENSE "LGPL-2.1-or-later")
set(DATA_VERSION ${LIBCHEWING_VERSION})
add_custom_command(
    OUTPUT
        ${ALL_DATA}
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內建詞庫
        ${DATA_SRC_DIR}/tsi.src tsi.dat
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內建字庫
        ${DATA_SRC_DIR}/word.src word.dat
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內嵌字庫
        ${DATA_SRC_DIR}/mini.src mini.dat
    COMMAND chewing-cli init-database
        -c ${DATA_COPYRIGHT}
        -l ${DATA_LICENSE}
        -r ${DATA_VERSION}
        -t trie
        -n 內嵌字庫
        ${DATA_SRC_DIR}/mini.src ${PROJECT_SOURCE_DIR}/capi/data/mini.dat
    DEPENDS
        chewing-cli
        ${DATA_SRC_DIR}/mini.src
        ${DATA_SRC_DIR}/word.src
        ${DATA_SRC_DIR}/tsi.src
    WORKING_DIRECTORY ${DATA_BIN_DIR}
)

install(FILES ${ALL_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)
install(FILES ${ALL_STATIC_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -7,21 +7,13 @@
     test-keyboard
     test-keyboardless
     test-logger
-    test-path
     test-regression
     test-reset
     test-special-symbol
     test-struct-size
     test-symbol
     test-userphrase
-    test-utf8
 )
-if(NOT WITH_RUST)
-    list(APPEND ALL_TESTCASES
-        test-key2pho
-        test-mmap
-    )
-endif()
 set(ALL_TESTTOOLS
     performance
     randkeystroke
@@ -57,9 +49,7 @@
 foreach(target ${ALL_TESTS})
     add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
     target_link_libraries(${target} testhelper)
-    if(WITH_RUST)
-        target_link_libraries(${target} chewing_testhelper)
-    endif(WITH_RUST)
+    target_link_libraries(${target} chewing_testhelper)
     target_link_libraries(${target} libchewing)
     target_compile_definitions(${target} PRIVATE
         CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
@@ -73,7 +63,14 @@
 
 add_library(testhelper STATIC
     ${TEST_SRC_DIR}/testhelper.c
-    $<TARGET_OBJECTS:common>
+    ${TEST_SRC_DIR}/porting_layer/src/asprintf.c
+    ${TEST_SRC_DIR}/porting_layer/src/asprintf.h
+    ${TEST_SRC_DIR}/porting_layer/include/plat_types.h
+    ${TEST_SRC_DIR}/porting_layer/include/sys/plat_posix.h
+    ${TEST_SRC_DIR}/porting_layer/include/sys/plat_windows.h
+)
+target_include_directories(testhelper PUBLIC
+        ${TEST_SRC_DIR}/porting_layer/include
 )
 target_compile_definitions(testhelper PRIVATE
     CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
@@ -103,7 +100,5 @@
     add_dependencies(check ${target})
 endforeach()
 
-if(WITH_RUST)
 add_test(NAME cargo-test-lib COMMAND cargo test --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
 add_test(NAME cargo-test-capi COMMAND cargo test -p chewing_capi --features $<$<BOOL:${WITH_SQLITE3}>:sqlite>)
-endif()

=== debian/changelog ===
libchewing (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Oct 2024 23:32:43 +0800

=== debian/control ===
Source: libchewing
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Kan-Ru Chen (陳侃如) <koster@debian.org>,
 Andrew Lee (李健秋) <ajqlee@debian.org>,
 YunQiang Su <syq@debian.org>,
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 corrosion,
 python3:native,
 cargo:native,
 rustc:native (>= 1.70),
 libstd-rust-dev,
 librust-der-0.7+default-dev (>= 0.7.7-~~),
 librust-der-0.7+std-dev (>= 0.7.7-~~),
 librust-directories-5+default-dev,
 librust-log-0.4+default-dev (>= 0.4.21-~~),
 librust-rusqlite+default-dev (>= 0.28.0-~~),
 librust-anyhow-1+default-dev,
 librust-clap-4+default-dev (>= 4.4.18-~~),
 librust-clap-4+derive-dev (>= 4.4.18-~~),
 librust-tempfile+default-dev (>= 3.10.1-~~),
 libncurses-dev,
 libsqlite3-dev,
 texinfo,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/input-method-team/libchewing
Vcs-Git: https://salsa.debian.org/input-method-team/libchewing.git
Rules-Requires-Root: no
Homepage: https://chewing.im

Package: libchewing3
Architecture: any
Multi-Arch: same
Depends:
 libchewing3-data (>= 0.4.0),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 scim-chewing (<< 0.3.3),
Provides:
 libchewing,
Description: intelligent phonetic input method library
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains shared library used by other programs.

Package: libchewing3-data
Architecture: all
Multi-Arch: foreign
Section: misc
Depends:
 ${misc:Depends},
Breaks:
 libchewing-data (<= 0.2.7),
Provides:
 libchewing-data,
Description: intelligent phonetic input method library - data files
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains data files of libchewing3.

Package: libchewing3-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libchewing3 (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libchewing-dev,
 libchewing1-dev,
 libchewing2-dev,
Description: intelligent phonetic input method library (developer version)
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains static library and header files for developer.

Package: chewing-tools
Architecture: any
Multi-Arch: foreign
Depends:
 libchewing3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: intelligent phonetic input method library (tools)
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains tools for chewing.

## libchewing 0.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.24.0)
+cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.9.1)
+set(CMAKE_PROJECT_VERSION 0.10.0)
 
 find_package(Git)
 if(Git_FOUND)
@@ -64,7 +64,7 @@
     FetchContent_Declare(
         Corrosion
         GIT_REPOSITORY https://github.com/corrosion-rs/corrosion.git
-        GIT_TAG 64289b1d79d6d19cd2e241db515381a086bb8407 # v0.5
+        GIT_TAG b1fab721655c5c4b1b08a083d3cd29f163af75d0 # v0.5.1
         FIND_PACKAGE_ARGS
     )
     FetchContent_MakeAvailable(Corrosion)
@@ -109,15 +109,8 @@
     endif()
 endif()
 
-include(CheckFunctionExists)
-check_function_exists(asprintf HAVE_ASPRINTF)
-
-include(CheckIncludeFiles)
-check_include_files(unistd.h HAVE_UNISTD_H)
-check_include_files(stdint.h HAVE_STDINT_H)
-
 set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
-set(INC_DIR ${PROJECT_SOURCE_DIR}/include)
+set(INC_DIR ${PROJECT_SOURCE_DIR}/capi/include)
 set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
 set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
 set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
@@ -152,8 +145,7 @@
 
 include_directories(
     ${PROJECT_BINARY_DIR}/include
-    ${PROJECT_SOURCE_DIR}/include
-    ${PROJECT_SOURCE_DIR}/src/porting_layer/include
+    ${PROJECT_SOURCE_DIR}/capi/include
 )
 
 set(ALL_INC
@@ -212,6 +204,7 @@
             PRIVATE /DEF:${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def
             PRIVATE /NODEFAULTLIB:MSVCRT
             PRIVATE /NODEFAULTLIB:MSVCRTD
+            PRIVATE /NODEFAULTLIB:LIBCMTD
         )
         set_target_properties(libchewing PROPERTIES
             LINK_DEPENDS ${PROJECT_SOURCE_DIR}/capi/src/symbols-msvc.def

=== debian/changelog ===
libchewing (0.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Jul 2025 22:53:20 +0800

## libchewing 0.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.10.0)
+set(CMAKE_PROJECT_VERSION 0.10.1)
 
 find_package(Git)
 if(Git_FOUND)
@@ -39,7 +39,7 @@
 option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
 
 if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
-    set(CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
+    set(CMAKE_C_FLAGS "-std=gnu99 -finput-charset=utf-8 ${CMAKE_C_FLAGS}")
     add_compile_definitions(_GNU_SOURCE)
     option(ENABLE_GCOV "Coverage support" false)
     if(ENABLE_GCOV)

=== debian/changelog ===
libchewing (0.10.1-1) unstable; urgency=medium

  * New upstream release.
  * d/salsa-ci.yml: Add Salsa CI config.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 02 Aug 2025 16:19:04 +0800

=== debian/tests/control ===
Tests: build
Depends:
 build-essential,
 libchewing3-dev,
 pkg-config,

## libchewing 0.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.10.1)
+set(CMAKE_PROJECT_VERSION 0.10.2)
 
 find_package(Git)
 if(Git_FOUND)

=== debian/changelog ===
libchewing (0.10.2-1) unstable; urgency=medium

  * New upstream version 0.10.2

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 14 Aug 2025 21:12:31 +0800
